package oracle.forms.fd;

import java.awt.Color;

import java.util.StringTokenizer;
import oracle.forms.handler.IHandler;
import oracle.forms.properties.ID;
import oracle.forms.ui.VCheckbox;
import oracle.forms.ui.VRadioButton;

  public class JRadioButtonMLline extends VRadioButton
  {
    public final static ID SetColors      = ID.registerProperty("SET_COLORS");  
    public final static ID SetTextColor   = ID.registerProperty("SET_TEXT_COLOR");      
    public final static ID SetPosition    = ID.registerProperty("SET_POSITION");          
    public final static ID SetAttach      = ID.registerProperty("SET_ATTACH");    
    public final static ID SetLog         = ID.registerProperty("SET_LOG");            
    private   MLToolTip tp = null ;
    private   IHandler  m_handler;  
    private String sSep = "|" ;
    
    public JRadioButtonMLline ()
    {
       super();
    }

    public boolean setProperty(ID property, Object value)
    {
       if(property.toString().equals("POPUPHELP_ID"))
       {
           String s = value.toString() ;
           oracle.forms.ui.FormsToolTip tpf = (oracle.forms.ui.FormsToolTip)value ;
           String stool = tpf.getToolTipProperty(ID.INDEX_POPUPHELP_STRING).toString() ;
           if(stool != null && ! stool.equals(""))
           {
             tp = new MLToolTip(stool, this);
           }
           return true ;
       }
       else if(property.toString().equals("LABEL"))
       {
         String s1 = (String)value ;
         String s2 = "" ;
         StringTokenizer st = new StringTokenizer(s1,sSep);
         if(st.hasMoreTokens())
         {
           while(st.hasMoreTokens())
           {
             s2 += st.nextToken() + "\n" ;
           }
           value = (Object)s2 ;
         }
         return super.setProperty(property, value);
       }
      else if(property==SetAttach)
       {
         String s = (String)value ;
         if(s.equalsIgnoreCase("MDI")) tp.setAttach(true);
         else tp.setAttach(false);
         return true ;
       }       
      else if(property==SetLog)
       {
         String s = (String)value ;
         if(s.equalsIgnoreCase("true")) tp.setLog(true);
         else tp.setLog(false);
         return true ;
       }       
      else if(property == SetColors)
      {
        String sColor = value.toString().trim();
        int r=-1, g=-1, b=-1;
        StringTokenizer st = new StringTokenizer(sColor,",");
        try{
          r = Integer.parseInt(st.nextToken()) ;
          g = Integer.parseInt(st.nextToken()) ;
          b = Integer.parseInt(st.nextToken()) ;    
          Color c1 = new Color(r,g,b) ;
          r=-1; g=-1; b=-1;
          r = Integer.parseInt(st.nextToken()) ;
          g = Integer.parseInt(st.nextToken()) ;
          b = Integer.parseInt(st.nextToken()) ;    
          Color c2 = new Color(r,g,b) ;         
          tp.setColors(c1,c2);
        }
        catch(Exception e) {e.printStackTrace();return false ;}
        return true ;
      }
      else if(property == SetTextColor)
      {
        String sColor = value.toString().trim();
        int r=-1, g=-1, b=-1, iNum = 0 ;
        StringTokenizer st = new StringTokenizer(sColor,",");
        try{
          r = Integer.parseInt(st.nextToken()) ;
          g = Integer.parseInt(st.nextToken()) ;
          b = Integer.parseInt(st.nextToken()) ;    
          tp.setTextColor(new Color(r,g,b));
        }
        catch(Exception e) {e.printStackTrace();return false ;}
        return true ;
      }       
      else if(property == SetPosition)
      {
        String s = value.toString();
        int iPos = s.indexOf(",") ;
        int iX=0, iY=0 ;
        if(iPos != -1)
        {
          try{
          iX = Integer.parseInt(s.substring(0,iPos-1)) ;
          iY = Integer.parseInt(s.substring(iPos+1)) ;
          tp.setPosition(iX, iY);
          }
          catch(NumberFormatException ne) { 
            System.out.println(" ** ERROR ** SetPosition parameter error -> "+s);
            return false ;
          }
        }
        return true ;
      }        
      else return super.setProperty(property, value);
    }

  }
