package oracle.forms.fd;

import java.awt.Color;
import java.io.PrintStream;
import java.util.StringTokenizer;
import oracle.forms.handler.IHandler;
import oracle.forms.properties.ID;
import oracle.forms.ui.FormsToolTip;
import oracle.forms.ui.VTextField;


public class JTextFieldTooltip extends VTextField
{

    public static final ID SetColors = ID.registerProperty("SET_COLORS");
    public static final ID SetTextColor = ID.registerProperty("SET_TEXT_COLOR");
    public static final ID SetPosition = ID.registerProperty("SET_POSITION");
    public static final ID SetAttach = ID.registerProperty("SET_ATTACH");
    public static final ID SetLog = ID.registerProperty("SET_LOG");
    private MLToolTip tp;
    private IHandler m_handler;
    private String sTooltip;
    private String sSep;

    private void init()
    {
        tp = null;
        sTooltip = "";
        sSep = "|";
    }

    public JTextFieldTooltip()
    {
        init();
    }

    public void init(IHandler handler)
    {
        super.init(handler);
    }

    public boolean setProperty(ID property, Object value)
    {
        if(property.toString().equals("POPUPHELP_ID"))
        {
            String s = value.toString();
            FormsToolTip tpf = (FormsToolTip)value;
            String stool = tpf.getToolTipProperty(409).toString();
            if(stool != null && !stool.equals(""))
                tp = new MLToolTip(stool, this);
            return true;
        }
        if(property == SetAttach)
        {
            String s = (String)value;
            if(s.equalsIgnoreCase("MDI"))
                tp.setAttach(true);
            else
                tp.setAttach(false);
            return true;
        }
        if(property == SetLog)
        {
            String s = (String)value;
            if(s.equalsIgnoreCase("true"))
                tp.setLog(true);
            else
                tp.setLog(false);
            return true;
        }
        if(property == SetColors)
        {
            String sColor = value.toString().trim();
            int r = -1;
            int g = -1;
            int b = -1;
            StringTokenizer st = new StringTokenizer(sColor, ",");
            try
            {
                r = Integer.parseInt(st.nextToken());
                g = Integer.parseInt(st.nextToken());
                b = Integer.parseInt(st.nextToken());
                Color c1 = new Color(r, g, b);
                r = -1;
                g = -1;
                b = -1;
                r = Integer.parseInt(st.nextToken());
                g = Integer.parseInt(st.nextToken());
                b = Integer.parseInt(st.nextToken());
                Color c2 = new Color(r, g, b);
                tp.setColors(c1, c2);
            }
            catch(Exception e)
            {
                e.printStackTrace();
                boolean flag = false;
                return flag;
            }
            return true;
        }
        if(property == SetTextColor)
        {
            String sColor = value.toString().trim();
            int r = -1;
            int g = -1;
            int b = -1;
            int iNum = 0;
            StringTokenizer st = new StringTokenizer(sColor, ",");
            try
            {
                r = Integer.parseInt(st.nextToken());
                g = Integer.parseInt(st.nextToken());
                b = Integer.parseInt(st.nextToken());
                tp.setTextColor(new Color(r, g, b));
            }
            catch(Exception e)
            {
                e.printStackTrace();
                boolean flag1 = false;
                return flag1;
            }
            return true;
        }
        if(property == SetPosition)
        {
            String s = value.toString();
            int iPos = s.indexOf(",");
            int iX = 0;
            int iY = 0;
            if(iPos != -1)
                try
                {
                    iX = Integer.parseInt(s.substring(0, iPos - 1));
                    iY = Integer.parseInt(s.substring(iPos + 1));
                    tp.setPosition(iX, iY);
                }
                catch(NumberFormatException ne)
                {
                    System.out.println(" ** ERROR ** SetPosition parameter error -> " + s);
                    boolean flag2 = false;
                    return flag2;
                }
            return true;
        } else
        {
            return super.setProperty(property, value);
        }
    }

}